﻿-- Author      : Nogarder
-- Create Date : 2014/12/1 3:23:34
--global 
local sqrt=sqrt
local abs=abs
local mod=mod
local sin=sin
--speed
local speed=10
--main
RS.Animation={}
--
local DefaultTime=0.2
--list
local RS_Animation_Alpha_List={}
local RS_Animation_Minimize_List={}
local RS_Animation_Blink_List={}
--macro for init alpha
local RS_Animation_InitAlpha=function(frame,time,endalpha)
	local time=time or DefaultTime
	local endalpha=endalpha or 1
	RS_Animation_Alpha_List[frame]={
		Count=time,
		Step=(endalpha-frame:GetAlpha())/time,
		EndAlpha=endalpha}
	frame:Show()
end
--
local RS_Animation_RestoreScroll=function(frame)
	local scroll=frame.Scroll
	local data=RS_Animation_Minimize_List[scroll]
	if(RS_Animation_Minimize_List[scroll])then
		scroll:SetWidth(data.Width)
		scroll.Frame:SetAlpha(1)
		scroll.Title:SetAlpha(1)
		RS_Animation_Minimize_List[scroll]=nil
		scroll.Minimized=nil
	end
end
--macro for show/hide frame
RS.Animation.ShowFrame=function(frame,time)
	if(frame)then
		RS_Animation_RestoreScroll(frame)
		frame:SetAlpha(0)
		frame:Show()
		RS_Animation_InitAlpha(frame,time,1)
	end
end
RS.Animation.HideFrame=function(frame,time)
	if(frame)then
		if(frame:IsShown() and (not RS_Animation_Alpha_List[frame]))then
			frame:SetAlpha(1)
			RS_Animation_InitAlpha(frame,time,0)
		end
	end
end
--macro for blink frame
RS.Animation.SetBlink=function(frame,enable)
	if(not enable)then
		if(RS_Animation_Blink_List[frame])then
			frame:SetAlpha(RS_Animation_Blink_List[frame])
		end
		RS_Animation_Blink_List[frame]=nil
	else
		if(not RS_Animation_Blink_List[frame])then
			RS_Animation_Blink_List[frame]=frame:GetAlpha()
		end
	end
end
--animation control
RS.OptionsMain:HookScript("OnUpdate",function(_,elapse)
	--alpha
	for frame,data in pairs(RS_Animation_Alpha_List)do
		data.Count=data.Count-elapse
		if(data.Count<0)then
			frame:SetAlpha(data.EndAlpha)
			if(data.EndAlpha==0)then
				frame:Hide()
				RS_Animation_RestoreScroll(frame)
			end
			RS_Animation_Alpha_List[frame]=nil
		else
			frame:SetAlpha(data.EndAlpha-data.Step*data.Count)
		end
	end
	--size
	for scroll,data in pairs(RS_Animation_Minimize_List)do
		data.Count=data.Count-elapse
		if(data.State==1)then
			--minimizing
			if(data.Count<0)then
				scroll:SetWidth(1)
				scroll.Frame:SetAlpha(0)
				scroll.Title:SetAlpha(0)
				data.State=3
				scroll.Minimized=true
				RS.RunFunc(scroll.OnMinimizedFunc)
			else
				scroll:SetWidth(1+data.Count*data.Step)
				local alpha=data.Count*data.AlphaStep
				scroll.Frame:SetAlpha(alpha)
				scroll.Title:SetAlpha(alpha)
			end
		elseif(data.State==2)then
			--restoring
			if(data.Count<0)then
				scroll:SetWidth(data.Width)
				scroll.Frame:SetAlpha(1)
				scroll.Title:SetAlpha(1)
				RS_Animation_Minimize_List[scroll]=nil
				scroll.Minimized=nil
				RS.Template.UpdateScrollFrame(scroll.Frame)
				--
				RS.RunFunc(scroll.OnRestoredFunc)
			else
				scroll:SetWidth(1+data.Width-data.Count*data.Step)
				local alpha=1-data.Count*data.AlphaStep
				scroll.Frame:SetAlpha(alpha)
				scroll.Title:SetAlpha(alpha)
			end
		end
	end
	for frame,alpha in pairs(RS_Animation_Blink_List)do
		if(frame:IsShown())then
			local value=mod(GetTime(),1)*360
			frame:SetAlpha((0.75+sin(value)/4)*alpha)
		end
	end
end)
--clear
RS.Animation.ClearPosition=function(frame)
	if(RS_Animation_Position_List[frame])then
		data=RS_Animation_Position_List[frame]
		frame:SetPoint("CENTER",frame:GetParent(),"CENTER",data.PosX,data.PosY)
		frame:SetAlpha(1)
		RS_Animation_Position_List[frame]=nil
	end
end
--
RS.Animation.ClearAlpha=function(frame)
	if(RS_Animation_Alpha_List[frame])then
		frame:SetAlpha(RS_Animation_Alpha_List[frame].EndAlpha)
		RS_Animation_Alpha_List[frame]=nil
	end
end
--
RS.Animation.IsWorking=function(scroll)
	if(RS_Animation_Minimize_List[scroll] and RS_Animation_Minimize_List[scroll].State~=3)then
		return true
	end
end
--
RS.Animation.NotHide=function(scroll)
	if(scroll:IsShown() and ((not RS_Animation_Alpha_List[scroll]) or RS_Animation_Alpha_List[scroll].EndAlpha~=0))then
		return true
	end
end
--
RS.Animation.IsMinimized=function(scroll)
	--not restoreing
	if(RS_Animation_Minimize_List[scroll] and RS_Animation_Minimize_List[scroll].State~=2)then
		return true
	end
end
---
--minimize
--1=minimizing
--2=restoring
--3=hang up
RS.Animation.RestoreScroll=function(scroll,time)
	if(not scroll)then
		return
	end
	if(RS_Animation_Minimize_List[scroll] and RS_Animation_Minimize_List[scroll].State==3)then
		local time=time or DefaultTime
		RS_Animation_Minimize_List[scroll].State=2
		RS_Animation_Minimize_List[scroll].Count=time
	end
end
RS.Animation.MinimizeScroll=function(scroll,time)
	if(not scroll)then
		return
	end
	local time=time or DefaultTime
	if(not RS_Animation_Minimize_List[scroll])then
		RS_Animation_Minimize_List[scroll]={
			State=1,
			Width=scroll:GetWidth(),
			Count=time,
			Step=scroll:GetWidth()/time,
			AlphaStep=1/time
		}
	else
		RS_Animation_Minimize_List[scroll].State=1
		RS_Animation_Minimize_List[scroll].Count=0
	end
end
RS.Animation.GetScrollWidth=function(scroll)
	if(RS_Animation_Minimize_List[scroll])then
		return RS_Animation_Minimize_List[scroll].Width
	else
		return scroll:GetWidth()
	end
end
--macro for clear all
RS.Animation.ClearAll=function()
	for frame,data in pairs(RS_Animation_Alpha_List)do
		frame:SetAlpha(data.EndAlpha)
		if(data.EndAlpha==0)then
			frame:Hide()
		end
		RS_Animation_Alpha_List[frame]=nil
	end
	for scroll,data in pairs(RS_Animation_Minimize_List)do
		scroll:SetWidth(data.Width)
		scroll.Frame:SetAlpha(1)
		scroll.Title:SetAlpha(1)
		RS_Animation_Minimize_List[scroll]=nil
		scroll.Minimized=nil
	end
	for frame,alpha in pairs(RS_Animation_Blink_List)do
		frame:SetAlpha(alpha)
		RS_Animation_Blink_List[frame]=nil
	end
end
