-- Author      : Nogarder
-- Create Date : 2015/3/1 23:51:00
local table_getn=table.getn

RS.Template.CreateCoolDownGroup=function(parent)
	local frame=RS.Template.CreateFrame(parent,10,10)
	
	frame.CoolDownIcons={}
	frame.CoolDownCount=0
	frame.LastUpdate=0
	frame.Parent=parent

	frame:HookScript("OnHide",function(self)
		if(self.OnCoolDown)then
			RS.Template.StopCoolDownMonitor(self.Parent.PlayerData,self)
		end
	end)

	local RS_Template_UpdateCoolDown=RS.Template.UpdateCoolDown
	frame:HookScript("OnUpdate",function(self)
		if(frame.CoolDownCount==0 or not frame.OnCoolDown)then
			return
		end
		--
		local nTime=GetTime()
		if(self.LastUpdate>nTime)then
			return
		end
		--
		self.LastUpdate=nTime+RS.UpdateInterval
		--
		local iconlist=frame.CoolDownIcons
		local name=parent.PlayerData.Name
		local percent=0
		for i=1,frame.CoolDownCount do
			local icon=iconlist[i]
			local endtime=RS.CoolDown.GetCoolDown(name,icon.SpellID)
			if(endtime and endtime>nTime)then
				local dpercent=1-(endtime-nTime)/icon.CDLength
				percent=percent+dpercent
				icon.Text:SetText(floor(endtime-nTime))
				RS.SetTextColorByPercent(icon.Text,dpercent)
				icon.Overlay:Show()
			else
				percent=percent+1
				icon.Text:SetText(icon.CDLength)
				icon.Text:SetTextColor(1,1,1,1)
				icon.Overlay:Hide()
			end
		end
		percent=percent/frame.CoolDownCount
		RS.Template.SetPlayerFramePercent(parent,percent)
	end)

	return frame
end

local GetSpellIcon=function(spellid)
	local _,_,icon=GetSpellInfo(spellid)
	return icon
end

RS.Template.UpdateCoolDownGroup=function(frame,width,height)
	local count=frame.CoolDownCount
	if(count==0)then
		return
	end
	local iconlist=frame.CoolDownIcons

	local offset=width/count
	local iconsize=offset
	if(iconsize>height)then
		iconsize=height
	end

	for i=1,count do
		local icon=iconlist[i]
		--
		icon:SetWidth(iconsize)
		icon:SetHeight(iconsize)
		icon.Text:SetFont(RS.TextFont,iconsize/3,RS.TextMode)

		icon:SetPoint("LEFT",frame,"LEFT",(i-1)*offset,0)
	end
end

RS.Template.ClearCoolDownGroup=function(frame)
	frame.CoolDownCount=0
	local iconlist=frame.CoolDownIcons
	for i=1,table_getn(iconlist)do
		iconlist[j]:Hide()
	end
end

RS.Template.SetCoolDownGroup=function(frame,cooldownlist)
	local iconlist=frame.CoolDownIcons
	local i=1
	for spellid,cdlength in pairs(cooldownlist) do
		if(not iconlist[i])then
			iconlist[i]=RS.Template.CreateCoolDown(frame)
		end
		local icon=iconlist[i]
		--
		icon.Texture:SetTexture(GetSpellIcon(spellid))
		icon.Text:SetText(cdlength)
		icon.CDLength=cdlength
		icon.SpellID=spellid

		icon.Texture:Show()
		icon.Text:Show()
		icon.Overlay:Hide()

		icon:Show()
		i=i+1
	end
	frame.CoolDownCount=i-1
	for j=i,table_getn(iconlist)do
		iconlist[j]:Hide()
	end

	RS.Template.UpdateCoolDownGroup(frame,frame:GetWidth(),frame:GetHeight())
end

RS.Template.StartCoolDownMonitor=function(playerdata,frame)
	if(playerdata)then
		frame.OnCoolDown=true
		local iconlist=frame.CoolDownIcons
		for i=1,frame.CoolDownCount do
			local icon=iconlist[i]
			if(icon.SpellID)then	
				RS.CoolDown.RegisterCoolDown(playerdata.Name,icon.SpellID,icon.CDLength,icon,true)
			end
		end
	end
end

RS.Template.StopCoolDownMonitor=function(playerdata,frame)
	frame.OnCoolDown=false
	local iconlist=frame.CoolDownIcons

	if(playerdata)then
		for i=1,frame.CoolDownCount do
			local icon=iconlist[i]
			if(icon.SpellID)then	
				RS.CoolDown.RegisterCoolDown(playerdata.Name,icon.SpellID,nil,icon,false)
			end
		end
	end
end