-- Author      : Nogarder
-- Create Date : 2015/3/2 2:11:11

RS.Template.SetPlayerFramePercent=function(frame,percent)
	frame.PercentTexture:SetWidth(frame:GetWidth()*(percent+0.01))
	RS.SetTextureColorByPercent(frame.PercentTexture,percent)

	--also check alive here
	if(RS.SpecAndSpells.IsUnitActive(frame.PlayerData.Name))then
		frame.DeadTexture:Hide()
		frame.Percent=percent
	else
		frame.DeadTexture:Show()
		frame.Percent=0
	end
end

RS.Template.CreatePlayerFrame=function(parent)
	local frame=RS.Template.CreateFrame(parent)
	
--	frame.RoleTexture=frame:CreateTexture()
--	frame.RoleTexture:SetPoint("TOPLEFT",frame,"TOPLEFT")
--	frame.RoleTexture:SetPoint("BOTTOMLEFT",frame,"LEFT")
--	frame.RoleTexture:SetTexture(RS.RoleTexture)
--	frame.RoleTexture:SetTexCoord(0,0,0,0)

	frame.DeadTexture=frame:CreateTexture(nil,"ARTWORK")
	frame.DeadTexture:SetPoint("TOPLEFT",frame,"TOPLEFT")
	frame.DeadTexture:SetPoint("BOTTOMRIGHT",frame,"RIGHT")
	frame.DeadTexture:SetTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcons")
	frame.DeadTexture:SetTexCoord(0.5,0.75,0.25,0.5)
	frame.DeadTexture:Hide()

	frame.PercentTexture=frame:CreateTexture(nil,"BORDER")
	frame.PercentTexture:SetPoint("TOPLEFT",frame,"TOPLEFT")
	frame.PercentTexture:SetPoint("BOTTOMLEFT",frame,"LEFT")
	frame.PercentTexture:SetTexture(0,0,0,0)
	frame.PercentTexture:SetTexCoord(0,0,0,0)

	frame.Label=RS.Template.CreateText(frame)
	frame.Label:SetPoint("TOPLEFT",frame,"TOPLEFT",2,0)
	frame.Label:SetPoint("BOTTOMRIGHT",frame,"RIGHT",-2,0)

	frame.CoolDownGroup=RS.Template.CreateCoolDownGroup(frame)
	frame.CoolDownGroup:SetPoint("TOPLEFT",frame,"LEFT",0,0)
	frame.CoolDownGroup:SetPoint("BOTTOMRIGHT",frame,"BOTTOMRIGHT",0,0)

	return frame
end
		
RS.Template.UpdatePlayerFrame=function(frame)
	local frameheight=frame:GetHeight()/2
	if(frameheight<2)then
		frameheight=2
	end
	local height=frame:GetWidth()/4
	if(height<5)then
		height=5
	elseif(height>frameheight)then
		height=frameheight
	end
		
	--frame.RoleTexture:SetWidth(height)
	frame.Label:SetFont(RS.TextFont,height,RS.TextMode)
	--using this to prevent anchor point update delay(it's really a problem)
	RS.Template.UpdateCoolDownGroup(frame.CoolDownGroup,frame:GetWidth(),frameheight) 
end

local RS_Template_SetCoolDownGroup=RS.Template.SetCoolDownGroup

RS.Template.SetPlayerFrame=function(playerframe,name,playerdata,enablemouse)
	playerframe.PlayerData=playerdata

	playerframe.Label:SetText(name)
	RS.SetTextColor(playerframe.Label,playerdata.Color)
	--RS.SetTexCoord(playerframe.RoleTexture,playerdata.RoleIcon)
	--set clickable
	playerframe:EnableMouse(enablemouse)
	playerframe.CoolDownGroup:EnableMouse(enablemouse)

	RS_Template_SetCoolDownGroup(playerframe.CoolDownGroup,playerdata.SelectedSpell)
end