-- Author      : Nogarder
-- Create Date : 2015/3/3 18:39:42

local CreateDragButton=function(ondragfunc,...)
	local dragframe=RS.Template.CreateButton(...)
	dragframe:SetMovable(true)

	dragframe:HookScript("OnMouseDown",function(self)
		self.MouseDown=true
		self.StartPointX,self.StartPointY=GetCursorPosition()
	end)
	dragframe:HookScript("OnMouseUp",function(self)
		self.MouseDown=false
	end)
	dragframe:HookScript("OnHide",function(self)
		self.MouseDown=false
	end)
	dragframe:HookScript("OnUpdate",function(self)
		if(self.MouseDown==true)then
			local x,y=GetCursorPosition()
			local dx=(x-self.StartPointX)
			local dy=(y-self.StartPointY)
			ondragfunc(dx,dy)
			self.StartPointX=x
			self.StartPointY=y
		end
	end)
	return dragframe
end

RS.Template.CreateFlexFrame=function(parent,onresizefunc)
	local frame=RS.Template.CreateFrame(parent,300,300)
	frame:SetPoint("CENTER",UIParent,"CENTER",0,0)
	frame:SetMovable(true)

	frame.TitleButton=RS.Template.CreateButton(frame,40,15)
	frame.TitleButton:SetPoint("BOTTOMLEFT",frame,"TOPLEFT")
	frame.TitleButton:SetPoint("BOTTOMRIGHT",frame,"TOPRIGHT")
	frame.TitleButton:HookScript("OnMouseDown",function(self)
		frame:StartMoving()
	end)
	frame.TitleButton:HookScript("OnMouseUp",function(self)
		frame:StopMovingOrSizing()
	end)

	frame.AnchorLeft=CreateDragButton(function(dx)
			local scale=frame:GetEffectiveScale()
			local dx=dx/scale
			local centerx,centery=frame:GetCenter()
			frame:ClearAllPoints()
			frame:SetPoint("CENTER",UIParent,"BOTTOMLEFT",centerx+dx/2,centery)
			local newwidth=frame:GetWidth()-dx
			if(newwidth<20)then
				newwidth=20
			end
			frame:SetWidth(newwidth)
			RS.RunFunc(onresizefunc,frame)
		end,
		frame,5,5,"<")
	frame.AnchorLeft:SetPoint("TOPRIGHT",frame,"TOPLEFT")
	frame.AnchorLeft:SetPoint("BOTTOMRIGHT",frame,"BOTTOMLEFT")

	frame.AnchorRight=CreateDragButton(function(dx)
			local scale=frame:GetEffectiveScale()
			local dx=dx/scale
			local centerx,centery=frame:GetCenter()
			frame:ClearAllPoints()
			frame:SetPoint("CENTER",UIParent,"BOTTOMLEFT",centerx+dx/2,centery)
			local newwidth=frame:GetWidth()+dx
			if(newwidth<20)then
				newwidth=20
			end
			frame:SetWidth(newwidth)
			RS.RunFunc(onresizefunc,frame)
		end,
		frame,5,5,">")
	frame.AnchorRight:SetPoint("TOPLEFT",frame,"TOPRIGHT")
	frame.AnchorRight:SetPoint("BOTTOMLEFT",frame,"BOTTOMRIGHT")

	frame.AnchorBottom=CreateDragButton(function(_,dy)
			local scale=frame:GetEffectiveScale()
			local dy=dy/scale
			local centerx,centery=frame:GetCenter()
			frame:ClearAllPoints()
			frame:SetPoint("CENTER",UIParent,"BOTTOMLEFT",centerx,centery+dy/2)
			local newheight=frame:GetHeight()-dy
			if(newheight<20)then
				newheight=20
			end
			frame:SetHeight(newheight)
			RS.RunFunc(onresizefunc,frame)
		end,
		frame,5,5,"v")
	frame.AnchorBottom:SetPoint("TOPLEFT",frame,"BOTTOMLEFT")
	frame.AnchorBottom:SetPoint("TOPRIGHT",frame,"BOTTOMRIGHT")

	frame:Show()

	return frame
end